"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRedisDataOfURL = exports.prismaDragonflyRedisCache = exports.defaultMutationMethods = void 0;
var tedis_1 = require("tedis");
exports.defaultMutationMethods = [
    "create",
    "createMany",
    "update",
    "updateMany",
    "upsert",
    "delete",
    "deleteMany",
    "executeRawUnsafe",
];
var prismaDragonflyRedisCacheMiddleware = /** @class */ (function () {
    function prismaDragonflyRedisCacheMiddleware(options) {
        var _this = this;
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        this.handle = function (params, next) { return __awaiter(_this, void 0, void 0, function () {
            var result, instance, data, cacheKey, tedis, _a, findCache, tedis, _b, keysData, keys, filtered, _i, keys_1, key;
            var _this = this;
            var _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        result = null;
                        instance = (this.useAllModels && this.defaultCacheActions.includes(params.action)) || ((_d = (_c = this.toCache) === null || _c === void 0 ? void 0 : _c.find) === null || _d === void 0 ? void 0 : _d.call(_c, function (instance) { return instance.model === params.model && (_this.defaultCacheActions.includes(params.action) || instance.actions.includes(params.action)); }));
                        if (!instance) return [3 /*break*/, 13];
                        data = typeof instance === "object" ? instance : { model: params.model, ttl: this.defaultTTL, prefix: "" };
                        if (!data.ttl && this.defaultTTL > 0)
                            data.ttl = this.defaultTTL;
                        cacheKey = "".concat(data.prefix ? "".concat(data.prefix, "-") : "").concat(params.model, ":").concat(params.action, ":").concat(JSON.stringify(params.args));
                        if (!this.isPool) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.getTedis()];
                    case 1:
                        _a = _e.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = this.client;
                        _e.label = 3;
                    case 3:
                        tedis = _a;
                        return [4 /*yield*/, tedis.get(cacheKey)];
                    case 4:
                        findCache = _e.sent();
                        if (!findCache) return [3 /*break*/, 5];
                        try {
                            result = JSON.parse(findCache);
                            if (this.debug)
                                console.log("[Dragonfly-Redis-Prisma-Cache] ".concat(params.model, ".").concat(params.action, "() received data from Cache"));
                        }
                        catch (e) {
                            console.error(e);
                        }
                        return [3 /*break*/, 10];
                    case 5: return [4 /*yield*/, next(params)];
                    case 6:
                        // using stringified results, because that way it uses PPC2 from dragonfly to save 54% storage space
                        result = _e.sent();
                        if (this.debug)
                            console.log("[Dragonfly-Redis-Prisma-Cache] Found something from the db and now storing it in:", cacheKey);
                        if (!data.ttl) return [3 /*break*/, 8];
                        return [4 /*yield*/, tedis.set(cacheKey, JSON.stringify(result, function (_, v) { return (typeof v === "bigint" ? v.toString() : v); }), 'EX', data.ttl)];
                    case 7:
                        _e.sent();
                        return [3 /*break*/, 10];
                    case 8: return [4 /*yield*/, tedis.set(cacheKey, JSON.stringify(result, function (_, v) { return (typeof v === "bigint" ? v.toString() : v); }))];
                    case 9:
                        _e.sent();
                        _e.label = 10;
                    case 10:
                        if (!this.isPool) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.client.putTedis(tedis)];
                    case 11:
                        _e.sent();
                        _e.label = 12;
                    case 12: return [3 /*break*/, 14];
                    case 13:
                        if (this.debug)
                            console.log("[Dragonfly-Redis-Prisma-Cache] Could not find instance for ".concat(params.model));
                        _e.label = 14;
                    case 14:
                        if (!!result) return [3 /*break*/, 16];
                        return [4 /*yield*/, next(params)];
                    case 15:
                        result = _e.sent();
                        _e.label = 16;
                    case 16:
                        if (!exports.defaultMutationMethods.includes(params.action)) return [3 /*break*/, 27];
                        if (!this.isPool) return [3 /*break*/, 18];
                        return [4 /*yield*/, this.client.getTedis()];
                    case 17:
                        _b = _e.sent();
                        return [3 /*break*/, 19];
                    case 18:
                        _b = this.client;
                        _e.label = 19;
                    case 19:
                        tedis = _b;
                        return [4 /*yield*/, tedis.keys("*".concat(params.model, ":*"))];
                    case 20:
                        keysData = _e.sent();
                        keys = [];
                        if (params.args.where) {
                            filtered = keysData.filter(function (k) { return k.includes(JSON.stringify(params.args.where)) || k.includes("findMany"); });
                            keys = filtered.length ? filtered : keysData;
                        }
                        _i = 0, keys_1 = keys;
                        _e.label = 21;
                    case 21:
                        if (!(_i < keys_1.length)) return [3 /*break*/, 24];
                        key = keys_1[_i];
                        return [4 /*yield*/, tedis.del(key)];
                    case 22:
                        _e.sent();
                        _e.label = 23;
                    case 23:
                        _i++;
                        return [3 /*break*/, 21];
                    case 24:
                        if (!this.isPool) return [3 /*break*/, 26];
                        return [4 /*yield*/, this.client.putTedis(tedis)];
                    case 25:
                        _e.sent();
                        _e.label = 26;
                    case 26:
                        if (this.debug)
                            console.log("[Dragonfly-Redis-Prisma-Cache] Invalidated ".concat(keys.length, " Keys after a mutationAction"));
                        _e.label = 27;
                    case 27: return [2 /*return*/, result];
                }
            });
        }); };
        validate(options);
        if (!options || (!options.toCache && !options.useAllModels) || !options.storageOptions)
            throw new SyntaxError("Something went wrong, not all options provided..");
        this.debug = (_a = options === null || options === void 0 ? void 0 : options.debug) !== null && _a !== void 0 ? _a : false;
        this.toCache = (_b = options === null || options === void 0 ? void 0 : options.toCache) !== null && _b !== void 0 ? _b : [];
        this.defaultTTL = (_c = options === null || options === void 0 ? void 0 : options.defaultTTL) !== null && _c !== void 0 ? _c : 0;
        this.defaultCacheActions = (_d = options.defaultCacheActions) !== null && _d !== void 0 ? _d : [];
        this.useAllModels = ((_e = options.useAllModels) !== null && _e !== void 0 ? _e : !((_f = options === null || options === void 0 ? void 0 : options.toCache) === null || _f === void 0 ? void 0 : _f.length)) ? true : false;
        this.isPool = !!(((_g = options === null || options === void 0 ? void 0 : options.storageOptions) === null || _g === void 0 ? void 0 : _g.min_conn) && options.storageOptions.min_conn >= 1);
        if (!this.isPool) {
            delete options.storageOptions.min_conn;
            delete options.storageOptions.max_conn;
        }
        else {
            // @ts-ignore
            if (!((_h = options.storageOptions) === null || _h === void 0 ? void 0 : _h.max_conn))
                options.storageOptions.max_conn = options.storageOptions.min_conn + 1;
            else if (((_j = options.storageOptions) === null || _j === void 0 ? void 0 : _j.max_conn) <= options.storageOptions.min_conn)
                options.storageOptions.max_conn = options.storageOptions.min_conn + 1;
        }
        this.client = this.isPool ? new tedis_1.TedisPool(options.storageOptions) : new tedis_1.Tedis(options.storageOptions);
    }
    return prismaDragonflyRedisCacheMiddleware;
}());
function validate(options) {
    if (!options || typeof options !== "object")
        throw new SyntaxError("no valid cacheOptions provided");
    if (typeof options.useAllModels !== "undefined" && typeof options.useAllModels !== "boolean")
        throw new SyntaxError("option useAllModels was not as a boolean provided");
    if (options.toCache && !Array.isArray(options.toCache))
        throw new SyntaxError("No option toCache was provided / option toCache is not a valid Array");
    if (!options.toCache && !options.useAllModels)
        throw new SyntaxError("No toCache and no useAllModels provided..");
    if (!options.defaultCacheActions || !Array.isArray(options.defaultCacheActions))
        throw new SyntaxError("No option defaultCacheActions was provided / option defaultCacheActions is not a valid Array");
    if (options.defaultTTL && typeof options.defaultTTL !== "number")
        throw new SyntaxError("Option defaultTTL provided but its not a number");
    if (options.defaultTTL && options.defaultTTL <= 0)
        throw new SyntaxError("Optuion defaultTTL provided but its smaller or equal to 0");
    if (options.debug && typeof options.debug !== "boolean")
        throw new SyntaxError("Option debug provided which is not a boolean");
    return true;
}
function prismaDragonflyRedisCache(options) {
    var newCache = new prismaDragonflyRedisCacheMiddleware(options);
    return newCache.handle;
}
exports.prismaDragonflyRedisCache = prismaDragonflyRedisCache;
/**
 * extract redis options of a redis connect uri. e.g: "redis://username:password@hostname:port"
 * @param str
 * @returns  object for redis authentication
 */
function getRedisDataOfURL(str) {
    var _a = str.replace("redis://", "").split(":").map(function (x) { return x.includes("@") ? x.split("@") : x; }), username = _a[0], _b = _a[1], password = _b[0], host = _b[1], port = _a[2];
    return { username: username, password: password, host: host, port: port };
}
exports.getRedisDataOfURL = getRedisDataOfURL;
